#include "Span.hpp"
#include <algorithm>
#include <bits/stdc++.h>

Span::Span()
{}

Span::Span(unsigned int N):
    _size(N)
{
}

Span::Span(const Span& src)
{
    *this = src;
}

Span::~Span()
{
}

Span& Span::operator=(const Span& src)
{
    this->_size = src._size;
    this->_vector = src._vector;
    return *this;
}

int Span::shortestSpan() const
{
    if (this->_vector.size() < 2)
        throw std::exception();
    std::vector<int> tmp = this->_vector;
    std::sort(tmp.begin(), tmp.end());
    int min_range = tmp[1] - tmp[0];
    for (unsigned int i = 1; i + 1 != tmp.size(); i++)
        if (min_range > tmp[i + 1] - tmp[i])
            min_range = tmp[i + 1] - tmp[i];
    return min_range;
}

int Span::longestSpan() const
{
    if (this->_vector.size() == 0)
        throw std::exception();
    return *std::max_element(this->_vector.begin(), this->_vector.end()) - *std::min_element(this->_vector.begin(), this->_vector.end());
}

void Span::addNumber(const int nb)
{
    if (this->_vector.size() == this->_size)
        throw std::exception();
    this->_vector.push_back(nb);
}